package com.gic.haoban.manage.service.service.out.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.crypto.SecureUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.JSONResponse;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.clerk.api.service.PowerService;
import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.dubbo.entity.ProviderLocalTag;
import com.gic.enterprise.api.dto.QRcodeDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.ImageService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.app.customer.dto.ChildDTO;
import com.gic.haoban.app.customer.dto.CustomerDTO;
import com.gic.haoban.app.customer.dto.FilterListDTO;
import com.gic.haoban.app.customer.dto.MemberInfoListParamsDTO;
import com.gic.haoban.app.customer.enums.GicQywxSyncTypeEnum;
import com.gic.haoban.app.customer.enums.QywxSyncTaskTypeEnum;
import com.gic.haoban.app.customer.service.api.service.CustomerApiService;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.constants.Manage3Constants;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.dto.hm.HmClerkRelationDTO;
import com.gic.haoban.manage.api.dto.hm.HmQrcodeDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.WxUserAddLogQDTO;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.enums.WelcomeMediaTypeEnum;
import com.gic.haoban.manage.api.enums.hm.HmWelcomeReferType;
import com.gic.haoban.manage.api.service.CheckQywxSettingApiService;
import com.gic.haoban.manage.api.service.ExternalClerkRelatedApiService;
import com.gic.haoban.manage.api.service.MaterialApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.hm.HmClerkRelationApiService;
import com.gic.haoban.manage.api.service.hm.HmQrcodeApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.StaffMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanExternalClerkRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.WxApplicationMapper;
import com.gic.haoban.manage.service.entity.*;
import com.gic.haoban.manage.service.exception.WxApiLimitException;
import com.gic.haoban.manage.service.pojo.DealQywxExternalUserPojo;
import com.gic.haoban.manage.service.pojo.ExternalUserPojo;
import com.gic.haoban.manage.service.pojo.QywxTagSyncInfoPojo;
import com.gic.haoban.manage.service.pojo.bo.hm.HmLinkBO;
import com.gic.haoban.manage.service.pojo.bo.hm.KeyDataLinkBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeDetailBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeMediaBO;
import com.gic.haoban.manage.service.pojo.bo.welcome.WelcomeReferBO;
import com.gic.haoban.manage.service.service.*;
import com.gic.haoban.manage.service.service.hm.HmLinkService;
import com.gic.haoban.manage.service.service.hm.WxUserAddLogService;
import com.gic.haoban.manage.service.util.CommonUtil;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberApiService;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberService;
import com.gic.member.api.service.MemberStoreService;
import com.gic.member.tag.api.dto.outapi.MemberTagSingleDTO;
import com.gic.member.tag.api.service.MemberTagOpenApiService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.redis.data.util.RedisUtil;
import com.gic.wechat.api.dto.qywx.*;
import com.gic.wechat.api.dto.qywx.welcome.*;
import com.gic.wechat.api.enums.QywxMediaTypeEnum;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.google.common.collect.Sets;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.redisson.api.RRateLimiter;
import org.redisson.api.RateIntervalUnit;
import org.redisson.api.RateType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.stream.Collectors;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService {

    private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
    private static final String SELF_APP = "selfSuiteId";
    /**
     * 限制次数
     */
    private static final Integer MAX_TIMES = 5;

    @Autowired
    private MemberUnionRelatedService memberUnionRelatedService;
    @Autowired
    private StaffService staffService;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private WxEnterpriseRelatedService wxEnterpriseRelatedService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;
    @Autowired
    private MemberOpenCardBusinessService memberOpenCardBusinessService;
    @Autowired
    private ClerkService clerkService;
    @Autowired
    private MemberUnionidRelatedMapper memberUnionidRelatedMapper;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private Config config;
    @Autowired
    private QywxSuiteApiService qywxSuiteApiService;
    @Autowired
    private MaterialApiService materialApiService;
    @Autowired
    private SecretSettingService secretSettingService;
    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private ExternalClerkRelatedService externalClerkRelatedService;
    @Autowired
    private PowerService powerService;
    @Autowired
    private MiniprogramSettingService miniprogramSettingService;
    @Autowired
    private WelcomeService welcomeService;
    @Autowired
    private CheckQywxSettingApiService checkQywxSettingApiService;
    @Autowired
    private CustomerApiService customerApiService;
    @Autowired
    private WxApplicationMapper wxApplicationMapper;
    @Autowired
    private MemberApiService memberApiService;
    @Autowired
    private TabHaobanExternalClerkRelatedMapper externalClerkRelatedMapper;
    @Autowired
    private ExternalClerkRelatedApiService externalClerkRelatedApiService;
    @Autowired
    private MemberStoreService memberStoreService;
    @Autowired
    private ImageService imageService;
    @Autowired
    private HmQrcodeApiService hmQrcodeApiService;
    @Autowired
    private WxUserAddLogService wxUserAddLogService;
    @Autowired
    private KeyDataService keyDataService;
    @Autowired
    private MemberTagOpenApiService memberTagOpenApiService;
    @Autowired
    private HmLinkService hmLinkService;
    @Autowired
    private MemberService memberService;
    @Autowired
    private HmClerkRelationApiService hmClerkRelationApiService;
    @Autowired
    private StaffMapper staffMapper ;
    

    @Override
    public void dealQywxExternalUser(String params) {
        log.info("处理外部联系人回调：{}", params);
        DealQywxExternalUserPojo externalUserPojo = JSONObject.parseObject(params, DealQywxExternalUserPojo.class);
        QwFrientNoticeDTO dto = externalUserPojo.getData() ;
        MemberUnionidRelatedDTO inDTO = EntityUtil.changeEntityByJSON(MemberUnionidRelatedDTO.class,dto) ;
        if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.del.getType()) {
            this.delMemberUnionidRelatedProcess(inDTO , dto.getWxUserId());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.add.getType()) {
            this.addMemberUnionidRelatedNew(inDTO , dto.getWxUserId());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.edit.getType()) {
            this.editMemberUnionidRelatedProcess(inDTO , dto.getWxUserId());
        }
    }

    @Override
    public List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String staffId, String storeId) {
        List<TabHaobanExternalClerkRelated> list = externalClerkRelatedService.listByExTernalUseridAndWxUserId(externalUserid, staffId);
        List<MemberStoreDTO> result = new ArrayList<>();
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        TabHaobanStaff haobanStaff = staffService.selectById(staffId) ;
        if (null == haobanStaff) {
            log.info("staff不存在");
            return null;
        }
        List<StaffClerkRelationDTO> clerkRelationDTOS = staffClerkRelationService.listBindCodeByStaffId(null, haobanStaff.getStaffId());
        if (CollectionUtil.isEmpty(clerkRelationDTOS)) {
            log.info("staff关联门店不存在1");
            return null;
        }
        List<String> storeIds = clerkRelationDTOS.stream().filter(s -> (s.getStoreId() != null || "".equals(s.getStoreId()))).map(s -> s.getStoreId()).collect(Collectors.toList());
        if (CollectionUtil.isEmpty(storeIds)) {
            log.info("staff关联门店不存在2");
            return null;
        }
        log.info("门店信息storeIds={}",JSON.toJSONString(storeIds));
        //2、获取member的storeId
        for (TabHaobanExternalClerkRelated tab : list) {
            if (StringUtils.isNotBlank(storeId) && (!storeId.equals(tab.getStoreId()))) {
                log.info("门店不符合,跳过");
                continue;
            }
            String memberId = tab.getMemberId();
            if (StringUtils.isEmpty(memberId)) {
                log.info("memberId null 跳过");
                continue;
            }
            CustomerDTO params = new CustomerDTO();
            params.setClerkType("0");
            params.setStoreId(tab.getStoreId());
            params.setClerkId(tab.getClerkId());
            params.setEnterpriseId(tab.getEnterpriseId());
            params.setStoreManagerFlag(isManager(tab.getClerkId()));

            MemberInfoListParamsDTO memberInfoListParamsDTO = new MemberInfoListParamsDTO();
            memberInfoListParamsDTO.setMemberId(memberId);

            FilterListDTO filterListDTO = new FilterListDTO();
            filterListDTO.setFilterType("4");
            ChildDTO childDTO = new ChildDTO();
            childDTO.setId("");
            filterListDTO.setChild(childDTO);
            List<FilterListDTO> filterList = new ArrayList<>();
            filterList.add(filterListDTO);

            memberInfoListParamsDTO.setFilterList(filterList);

            boolean flag = customerApiService.checkMemberRangeByMemberId(params, memberInfoListParamsDTO);
            MemberStoreDTO dto = new MemberStoreDTO();
            dto.setMemberId(tab.getMemberId());
            dto.setStoreId(tab.getStoreId());
            if (flag) {
                dto.setHasRight(1);
            } else {
                dto.setHasRight(0);
            }
            result.add(dto);
        }
        return result;
    }

    private boolean isManager(String clerkId) {
        ClerkDTO clerkDTO = clerkService.getclerkById(clerkId);
        if (clerkDTO != null) {
            Integer isManager = clerkDTO.getClerkType();
            return isManager != null && isManager == 1 && clerkDTO.getStatus() == 1;
        }
        return false;
    }

    /**
     * 根据导购导购微信id和会员id查询关联关系
     *
     * @return : 返回关联关系
     */
    @Override
    public ExternalClerkRelatedDTO getByWxUserIdMemberId(String staffId, String memberId) {
        return externalClerkRelatedService.getByMemberId(staffId, memberId);
    }

    @Override
    public String addMemberUnionidRelated(QwFrientNoticeDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.add.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
        return null;
    }


    @Override
    public String addMemberUnionidRelatedNew(MemberUnionidRelatedDTO dto, String wxUserId) {
        //解析组装信息
        dto = getMemberUnionidRelatedDTONew(dto,wxUserId);
        if (null == dto) {
            log.info("没处理完成-等下一次处理");
            return null;
        }
        insertExternalClerkRelatedNew(dto,wxUserId);
        return dto.getMemberUnionidRelatedId();
    }

    /**
     * 创建关联关系
     *
     * @param dto
     */
    private void insertExternalClerkRelatedNew(MemberUnionidRelatedDTO dto, String wxUserId) {
        log.info("新增外部联系人，创建关联关系：{}", JSON.toJSONString(dto));
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserid();
        String unionid = dto.getUnionid();
        String state = dto.getState();
        boolean isHmUnionid = false;
        String mobile = "";
        log.info("新增外部联系人,wxEnterpriseId:{}", wxEnterpriseId);
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, externalUserId)) {
            log.error("新增外部联系人，缺少必须字段：wxUserId:{},wxEnterpriseId:{},name:{},createTime:{},externalUserId:{}", wxUserId, wxEnterpriseId, name, createTime, externalUserId);
            //checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId,null,  dto);
            return;
        }
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            log.info("staff不存在：{},{}", dto.getUnionid(), wxUserId);
            return;
        }
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            log.info("未查询到企业：wxEnterpriseId:{}", wxEnterpriseId);
            return;
        }
        String staffId = staff.getStaffId();
        String staffName = staff.getStaffName();
        log.info("新增外部联系人,staffId={}",staffId);
        StaffClerkRelationDTO staffClerkRelationDTO = null;
        //活码处理 "DT" "HM"
        WxUserAddLogQDTO wxUserAddLogQDTO = new WxUserAddLogQDTO();
        String memberLabelId = "";
        if (StringUtils.isNotBlank(state) && (state.startsWith(Manage3Constants.HM) || state.startsWith(Manage3Constants.DT))) {
            String id = state.substring(2);
            Long hmId = null;
            HmQrcodeDTO hmQrcodeDTO = null;
            if (state.contains(Manage3Constants.HM)) {
                hmId = Convert.toLong(id);
                log.info("普通活码={}", hmId);
                hmQrcodeDTO = hmQrcodeApiService.getSimpleById(hmId);
                if (hmQrcodeDTO == null) {
                    log.error("活码为空：{}", hmId);
                    return;
                }
                memberLabelId = hmQrcodeDTO.getMemberLabelId();
                wxUserAddLogQDTO.setHmId(hmId);
                //处理活码导购
                if (hmQrcodeDTO.getHmType() == 1) {
                    staffClerkRelationDTO = staffClerkRelationService.getBindByClerkId(hmQrcodeDTO.getClerkId(), wxEnterpriseId);
                } else if (hmQrcodeDTO.getHmType() == 2) {
                    HmClerkRelationDTO hmClerkRelationDTO = null;
                    //有主门店导购绑定主导购，没有主门店导购绑定第一个导购，其余随机
                    TabHaobanClerkMainStoreRelated mainStoreRelated = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
                    if (mainStoreRelated != null) {
                        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, mainStoreRelated.getStoreId());
                        hmClerkRelationDTO = hmClerkRelationApiService.getHmClerkByHmIdAndClerkId(hmId, relationDTO.getClerkId());
                        if (hmClerkRelationDTO == null) {
                            hmClerkRelationDTO = hmClerkRelationApiService.getOneHmClerkByHmIdAndStaffId(hmId, staffId);
                            if (hmClerkRelationDTO == null) {
                                hmClerkRelationDTO = hmClerkRelationApiService.getOneHmClerkByHmId(hmId);
                            }
                        }
                    } else {
                        hmClerkRelationDTO = hmClerkRelationApiService.getOneHmClerkByHmId(hmId);
                    }
                    staffClerkRelationDTO = staffClerkRelationService.getBindByClerkId(hmClerkRelationDTO.getClerkId(), wxEnterpriseId);
                }
            } else if (state.contains(Manage3Constants.DT)) {
                KeyDataLinkBO dataForHmLink = keyDataService.getDataForHmLink(id);
                Long linkId = dataForHmLink.getLinkId();
                hmId = dataForHmLink.getHmId();
                mobile = dataForHmLink.getMobile();
                unionid = dataForHmLink.getUnionid();
                log.info("动态活码hmId={},linkId={},unionid={}", hmId, linkId, unionid);
                isHmUnionid = true;
                wxUserAddLogQDTO.setLinkId(linkId);
                wxUserAddLogQDTO.setHmId(hmId);
                hmQrcodeDTO = hmQrcodeApiService.getSimpleById(hmId);
                if (hmQrcodeDTO == null) {
                    log.error("活码动态为空,hmId:{}", hmId);
                    return;
                }
                staffClerkRelationDTO = staffClerkRelationService.getBindByClerkId(hmQrcodeDTO.getClerkId(), wxEnterpriseId);
                HmLinkBO hmLinkBO = hmLinkService.getByLinkId(wxEnterpriseId, null, linkId);
                if (hmLinkBO != null) {
                    memberLabelId = hmLinkBO.getMemberLabelId();
                }
            } else {
                //不是我们的活码
                TabHaobanClerkMainStoreRelated mainStoreRelated = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
                if (mainStoreRelated == null) {
                    log.info("【新增外部联系人】主门店为空:{}", staffId);
                    // 无主门店仅发送欢迎语
                    sendWelcome(dto, qwDTO, null, staffId, null);
                    return;
                }
                staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, mainStoreRelated.getStoreId());
            }
            if (hmId != null && hmQrcodeDTO != null) {
                log.info("计算活码的上限和加好友数量：{}", hmId);
                hmQrcodeApiService.updateAddNumById(hmId, hmQrcodeDTO.getClerkId());
            }
        } else {
            TabHaobanClerkMainStoreRelated mainStoreRelated = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
            if (mainStoreRelated == null) {
                log.info("【新增外部联系人】主门店为空:staffId={}", staffId);
                // 无主门店仅发送欢迎语
                sendWelcome(dto, qwDTO, null, staffId, null);
                return;
            }
            staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, mainStoreRelated.getStoreId());
        }
        if (staffClerkRelationDTO == null) {
            log.info("【新增外部联系人】导购和clerk关联为空");
            return;
        }
        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        TabHaobanWxEnterpriseRelated wxEnterpriseRelated = wxEnterpriseRelatedService.getByEnterpriseId(wxEnterpriseId, enterpriseId);
        if (wxEnterpriseRelated == null) {
            log.info("没有存在企业关联：{},{}", staffClerkRelationDTO.getWxEnterpriseId(), enterpriseId);
            return;
        }

        String memberId = null;
        if (StringUtils.isNotBlank(unionid)) {
            log.info("有unionid处理：wxEnterpriseId:{}，unionid：{}", wxEnterpriseId, unionid);
            dto.setUnionid(unionid);
            memberId = addExternalClerkRelated(dto, staffId, staffClerkRelationDTO, wxEnterpriseRelated, isHmUnionid, mobile , wxUserId);
        } else {
            log.info("发送欢迎语逻辑：wxEnterpriseId:{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
        }

        if (StringUtils.isNoneBlank(memberId, memberLabelId)) {
            //设置会员标签
            setMemberTag(staffClerkRelationDTO, memberLabelId, memberId);
        }

        //加好友增加数量
        staffService.updateAddNumById(staffId);
        log.info("插入加好友日志");
        wxUserAddLogQDTO.setWxEnterpriseId(wxEnterpriseId);
        wxUserAddLogQDTO.setEnterpriseId(enterpriseId);
        wxUserAddLogQDTO.setMemberId(memberId);
        wxUserAddLogQDTO.setUnionid(unionid);
        wxUserAddLogQDTO.setDelFlag(false);
        wxUserAddLogQDTO.setExternalUserid(externalUserId);
        wxUserAddLogQDTO.setStaffId(staffId);
        wxUserAddLogQDTO.setStaffName(staffName);
        wxUserAddLogQDTO.setClerkId(staffClerkRelationDTO.getClerkId());
        wxUserAddLogService.save(wxUserAddLogQDTO);
    }

    /**
     * 设置活码标签
     *
     * @param staffClerkRelationDTO
     * @param memberLabelId
     * @param memberId
     */
    private void setMemberTag(StaffClerkRelationDTO staffClerkRelationDTO, String memberLabelId, String memberId) {
        log.info("会员打标签,memberLabelId:{},memberId:{}", memberLabelId, memberId);
        if (StringUtils.isNotBlank(memberLabelId)) {
            MemberTagSingleDTO tagSingleDTO = new MemberTagSingleDTO();
            tagSingleDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            tagSingleDTO.setOptType(0);
            tagSingleDTO.setMemberId(memberId);
            tagSingleDTO.setTagItemIdList(Collections.singletonList(memberLabelId));
            this.memberTagOpenApiService.saveMemberTagSingle(tagSingleDTO);
        }
    }

    /**
     * 根据统一开平和不同开平 处理不同的添加好友关系
     *
     * @param dto
     * @param staffId
     * @param staffClerkRelationDTO
     * @param wxEnterpriseRelated
     */
    private String addExternalClerkRelated(MemberUnionidRelatedDTO dto, String staffId, StaffClerkRelationDTO staffClerkRelationDTO,
                                           TabHaobanWxEnterpriseRelated wxEnterpriseRelated, boolean isHmUnionid, String mobile, String wxUserId) {
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserid = dto.getExternalUserid();
        String avatar = dto.getAvatar();
        if (wxEnterpriseRelated.getMemberOpenCardFlag() == 1 && (!isHmUnionid)) {
            log.info("不同开平，走欢迎语逻辑，wxEnterpriseId：{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
            return "";
        }
        log.info("同一开平，创建关联关系...");
        String unionId = dto.getUnionid();
        if (StringUtils.isBlank(unionId)) {
            log.info("unionid不存在,走发送欢迎语逻辑：wxEnterpriseId:{}", wxEnterpriseId);
            addFriendByWelcome(dto, staffClerkRelationDTO);
            return "";
        }
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        //新增导购和外部联系人关系
        String clerkId = staffClerkRelationDTO.getClerkId();
        String clerkCode = staffClerkRelationDTO.getClerkCode();
        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        ClerkDTO clerk = clerkService.getClerkByClerkCode(enterpriseId, clerkCode);
        log.info("【新增外部联系人】clerkCode={},unionid:{}", clerkCode, unionId);
        if (clerk == null) {
            log.info("【新增外部联系人】导购为空:{},{}", clerkCode, unionId);
            return "";
        }

        String qrcodeParam = clerk.getQrcodeParam();
        if (StringUtils.isBlank(qrcodeParam)) {
            powerService.saveClerkQrCode(clerk.getClerkId());
            clerk = clerkService.getClerkByClerkCode(enterpriseId, clerkCode);
            qrcodeParam = clerk.getQrcodeParam();
        }
        if (StringUtils.isBlank(qrcodeParam)) {
            log.info("不能生产导购二维码：{}", JSONObject.toJSONString(clerk));
            return "";
        }

        MemberDTO member = null;
        if (isHmUnionid) {
            if (StringUtils.isNotBlank(mobile)) {
                log.info("根据手机号查询会员：{},{}", enterpriseId, mobile);
                member = memberService.getMemberByPhone(enterpriseId, mobile);
            }
        }

        if (member == null) {
            log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}", enterpriseId, unionId, name, avatar, qrcodeParam);
            member = memberOpenCardBusinessService.getMemberByQywxChannelParam(enterpriseId, unionId, "", name, avatar, qrcodeParam);
        }

        if (member == null) {
            log.info("生产会员memberid失败：{}", unionId);
            return "";
        }

        String memberId = member.getMemberId();
        List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserid, staffId);
        String relationKey = SecureUtil.md5(staffId + externalUserid);
        String memberUnionidRelatedId = dto.getMemberUnionidRelatedId();
        if (CollectionUtils.isEmpty(externalClerkRelateds)) {
            log.info("新增TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserid);
            related.setStaffId(staffId);
            related.setHeadUrl(dto.getAvatar());
            related.setMemberUnionidRelatedId(memberUnionidRelatedId);
            related.setStoreId(staffClerkRelationDTO.getStoreId());
            related.setRelationKey(relationKey);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setMemberId(memberId);
            externalClerkRelatedService.insert(related);
        } else {
            log.info("更新TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
            exsitDTO.setMemberId(memberId);
            exsitDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
            exsitDTO.setExternalUserId(externalUserid);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setRelationKey(relationKey);
            exsitDTO.setHeadUrl(dto.getAvatar());
            exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setClerkId(clerkId);
            exsitDTO.setStatusFlag(1);
            externalClerkRelatedService.update(exsitDTO);
        }
        MemberUnionidRelatedDTO memberUnionidRelatedDTO = new MemberUnionidRelatedDTO();
        memberUnionidRelatedDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
        memberUnionidRelatedDTO.setEnterpriseId(enterpriseId);
        memberUnionidRelatedDTO.setStaffId(staffId);
        memberUnionidRelatedDTO.setUnionid(unionId);
        memberUnionidRelatedDTO.setMemberId(memberId);
        memberUnionRelatedService.update(memberUnionidRelatedDTO);

        sendWelcome(dto, qwDTO, enterpriseId, staffId, clerkId);
        //同步好友标签
        pushTagSync(memberId, wxEnterpriseId, enterpriseId);
        //回调给会员，更新是否为企微好友
        log.info("通知会员 合并会员后更新为企微好友,memberId:{}", memberId);
        memberApiService.updateMemberQywxFlag(enterpriseId, memberId, 1);
        return memberId;
    }


    /**
     * 欢迎语新增好友
     *
     * @param dto
     */
    private void addFriendByWelcome(MemberUnionidRelatedDTO dto, StaffClerkRelationDTO staffClerkRelationDTO) {
        String staffId = staffClerkRelationDTO.getStaffId();
        String clerkId = staffClerkRelationDTO.getClerkId();
        String relationKey = SecureUtil.md5(staffId + dto.getExternalUserid());
        String wxEnterpriseId = staffClerkRelationDTO.getWxEnterpriseId();
        String enterpriseId = staffClerkRelationDTO.getEnterpriseId();
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        //发送欢迎语
        sendWelcome(dto, qwDTO, enterpriseId, staffId, clerkId);
        //保存好友关系
        List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, dto.getExternalUserid(), staffId);
        String memberUnionidRelatedId = dto.getMemberUnionidRelatedId();
        if (CollectionUtils.isEmpty(externalClerkRelateds)) {
            log.info("新增TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(dto.getAddCreateTime());
            related.setClerkId(staffClerkRelationDTO.getClerkId());
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(dto.getExternalName());
            related.setExternalUserId(dto.getExternalUserid());
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(memberUnionidRelatedId);
            related.setStoreId(staffClerkRelationDTO.getStoreId());
            related.setRelationKey(relationKey);
            related.setStatusFlag(4);
            related.setPushTimes(1);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setHeadUrl(dto.getAvatar());
            externalClerkRelatedService.insert(related);
        } else {
            log.info("更新TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
            exsitDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
            exsitDTO.setExternalUserId(dto.getExternalUserid());
            exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
            exsitDTO.setRelationKey(relationKey);
            exsitDTO.setHeadUrl(dto.getAvatar());
            exsitDTO.setStatusFlag(4);
            externalClerkRelatedService.update(exsitDTO);
        }
        MemberUnionidRelatedDTO memberUnionidRelatedDTO = new MemberUnionidRelatedDTO();
        memberUnionidRelatedDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
        memberUnionidRelatedDTO.setEnterpriseId(enterpriseId);
        memberUnionidRelatedDTO.setStaffId(staffId);
        memberUnionRelatedService.update(memberUnionidRelatedDTO);
    }

    /**
     * 发送欢迎语
     *
     * @param dto
     * @param wxEnterpriseDTO
     * @param enterpriseId
     * @param staffId
     */
    private void sendWelcome(MemberUnionidRelatedDTO dto, WxEnterpriseQwDTO wxEnterpriseDTO, String enterpriseId, String staffId, String clerkId) {
        log.info("发送欢迎语：dto:{},staffId:{}", JSONObject.toJSONString(dto), staffId);
        String welcomeCode = dto.getWelcomeCode();
        String state = dto.getState();
        String wxEnterpriseId = wxEnterpriseDTO.getWxEnterpriseId();
        if (StringUtils.isBlank(welcomeCode)) {
            log.error("welcomeCode为空，请检查是否使用企微的欢迎语：{}", wxEnterpriseId);
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                QywxErrorLogDTO qywxErrorLogDTO = new QywxErrorLogDTO();
                qywxErrorLogDTO.setWxEnterpriseId(wxEnterpriseId);
                qywxErrorLogDTO.setCorpid(dto.getCorpid());
                qywxErrorLogDTO.setScenario("欢迎语不发送");
                qywxErrorLogDTO.setErrorContent("welcomeCode为空，请检查是否使用企微的欢迎语");
                qywxErrorLogDTO.setTraceId(ProviderLocalTag.tag.get().traceId);
                qywxErrorLogDTO.setQywxErrorType(1);
                clientInstance.sendMessage(Manage3Constants.QYWX_ERROR_MSG, JSON.toJSONString(qywxErrorLogDTO));
            } catch (Exception e) {
                log.error("发送消息失败：{}", e.getMessage(), e);
            }
            return;
        }
        String relationKey = SecureUtil.md5(staffId + dto.getExternalUserid());

        WelcomeDetailBO welcomeDetailBO = null;
        if (StringUtils.isNotBlank(state) && (state.startsWith(Manage3Constants.HM) || state.startsWith(Manage3Constants.DT))) {
            //"HM+id" "DT+key"
            log.info("特殊欢迎语 state:{}", state);
            WelcomeReferBO welcomeReferBo = getWelcomeReferBo(state);
            welcomeDetailBO = welcomeService.getMatchWelcomeWithReferId(staffId, wxEnterpriseId, welcomeReferBo);
        } else {
            welcomeDetailBO = welcomeService.getMatchWelcome(staffId, wxEnterpriseId);
        }

        if (Objects.isNull(welcomeDetailBO)) {
            log.info("欢迎语未配置：wxEnterpriseId:{}", wxEnterpriseId);
            return;
        }
        //内容
        String content = welcomeDetailBO.getWelcomeContent().replaceAll("<微信昵称>", Matcher.quoteReplacement(dto.getExternalName()));
        QywxWelcomeMsgDTO qywxWelcomeMsgDTO = new QywxWelcomeMsgDTO();
        // 欢迎语内容
        qywxWelcomeMsgDTO.setText(content);
        //欢迎语类型
        List<QywxExternalMessageBaseDTO> attachments = new ArrayList<>();
        // 开始设置欢迎语附件
        List<WelcomeMediaBO> mediaList = welcomeDetailBO.getWelcomeMediaList();
        log.info("欢迎语发送附件list:{}", JSON.toJSONString(mediaList));
        mediaList.forEach(one -> {
            Integer mediaType = one.getMediaType();
            if (WelcomeMediaTypeEnum.IMAGE.getCode().equals(mediaType)) {
                attachmentAddImage(attachments, one, wxEnterpriseDTO.getThirdCorpid());
            }
            if (WelcomeMediaTypeEnum.VIDEO.getCode().equals(mediaType)) {
                attachmentAddVideo(attachments, one, wxEnterpriseDTO.getThirdCorpid());
            }
            if (WelcomeMediaTypeEnum.FILE.getCode().equals(mediaType)) {
                attachmentAddFile(attachments, one, wxEnterpriseDTO.getThirdCorpid());
            }
            if (WelcomeMediaTypeEnum.LINK.getCode().equals(mediaType)) {
                attachmentAddLink(attachments, one);
            }
            if (WelcomeMediaTypeEnum.PROGRAM.getCode().equals(mediaType)) {
                attachmentAddProgram(attachments, one, wxEnterpriseId);
            }
            if (WelcomeMediaTypeEnum.PARAM_PROGRAM.getCode().equals(mediaType)) {
                attachmentAddParamProgram(attachments, enterpriseId, wxEnterpriseId, relationKey);
            }
            if (WelcomeMediaTypeEnum.PARAM_QRCODE.getCode().equals(mediaType)) {
                attachmentAddParamQrCode(attachments, enterpriseId, clerkId, wxEnterpriseDTO.getThirdCorpid(), relationKey);
            }
        });
        if (CollectionUtils.isNotEmpty(attachments)) {
            qywxWelcomeMsgDTO.setAttachments(attachments);
        }
        qywxWelcomeMsgDTO.setWelcomeCode(welcomeCode);
        log.info("[sendWelcome] 发送欢迎语 params:{}", JSON.toJSONString(qywxWelcomeMsgDTO));
        if (dto.getSuiteid().equals(SELF_APP)) {
            //好办助手和代开发
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(dto.getWxEnterpriseId(), SecretTypeEnum.CUSTOMIZED_APP.getVal());
            qywxUserApiService.sendSelfWelcomeMsgByExternal(dto.getCorpid(), secretSetting.getSecretVal(), qywxWelcomeMsgDTO);
        } else {
            qywxUserApiService.sendWelcomeMsgByExternal(dto.getCorpid(), config.getWxSuiteid(), qywxWelcomeMsgDTO);
        }
    }

    /**
     * 获取链接或者活码id
     *
     * @param state
     * @return
     */
    private WelcomeReferBO getWelcomeReferBo(String state) {
        WelcomeReferBO welcomeReferBo = new WelcomeReferBO();
        String id = state.substring(2);
        if (state.contains(Manage3Constants.HM)) {
            welcomeReferBo.setType(HmWelcomeReferType.HM.getCode());
            welcomeReferBo.setReferId(id);
        } else if (state.contains(Manage3Constants.DT)) {
            KeyDataLinkBO dataForHmLink = keyDataService.getDataForHmLink(id);
            if (dataForHmLink != null) {
                welcomeReferBo.setType(HmWelcomeReferType.LINK.getCode());
                welcomeReferBo.setReferId(Convert.toStr(dataForHmLink.getLinkId()));
            }
        }
        return welcomeReferBo;
    }

    private void attachmentAddImage(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, String corpid) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                corpid,
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.IMAGE.getCode());
        log.info("欢迎语发送图片返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxImageExternalBaseDTO qywxImageExternalBaseDTO = new QywxImageExternalBaseDTO();
            qywxImageExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxImageExternalBaseDTO);
        }
    }

    private void attachmentAddVideo(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, String corpid) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                corpid,
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.VIDEO.getCode());
        log.info("欢迎语发送视频返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxVideoExternalBaseDTO qywxVideoExternalBaseDTO = new QywxVideoExternalBaseDTO();
            qywxVideoExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxVideoExternalBaseDTO);
        }
    }

    private void attachmentAddFile(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, String corpid) {
        String mediaUrl = media.getMediaUrl();
        String[] arr = mediaUrl.split("/");
        JSONResponse jp = qywxSuiteApiService.uploadMedia(
                corpid,
                config.getWxSuiteid(),
                CommonUtil.getFileByte(mediaUrl),
                arr[arr.length - 1],
                QywxMediaTypeEnum.FILE.getCode());
        log.info("欢迎语发送文件返回：{}", JSON.toJSONString(jp));
        if (jp.getErrorCode() == 0) {
            QywxFileExternalBaseDTO qywxFileExternalBaseDTO = new QywxFileExternalBaseDTO();
            qywxFileExternalBaseDTO.setMediaId(jp.getResult().toString());
            attachments.add(qywxFileExternalBaseDTO);
        }
    }

    private void attachmentAddLink(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media) {
        String mediaTitle = media.getMediaTitle();
        String mediaUrl = media.getMediaUrl();
        QywxLinkExternalBaseDTO qywxLinkExternalBaseDTO = new QywxLinkExternalBaseDTO();
        qywxLinkExternalBaseDTO.setTitle(mediaTitle);
        qywxLinkExternalBaseDTO.setUrl(mediaUrl);
        attachments.add(qywxLinkExternalBaseDTO);
    }

    private void attachmentAddProgram(List<QywxExternalMessageBaseDTO> attachments, WelcomeMediaBO media, String wxEnterpriseId) {
        log.info("发送小程序：wxEnterpriseId:{}", wxEnterpriseId);
        String miniprogramSettingId = media.getMiniprogramSettingId();
        TabMiniprogramSetting miniprogramSetting = miniprogramSettingService.getById(miniprogramSettingId);
        if (Objects.isNull(miniprogramSetting) || miniprogramSetting.getStatusFlag() == 0) {
            log.info("小程序不存在或已被删除, miniprogramSettingId:{}", miniprogramSettingId);
            return;
        }
        QywxMiniprogramExternalBaseDTO messageBaseDTO = new QywxMiniprogramExternalBaseDTO();
        messageBaseDTO.setAppid(miniprogramSetting.getAppId());
        messageBaseDTO.setPicMediaId(miniprogramSetting.getMediaId());
        messageBaseDTO.setTitle(miniprogramSetting.getTitle());
        messageBaseDTO.setPage(media.getMiniProgramPage());
        attachments.add(messageBaseDTO);
    }

    private void attachmentAddParamProgram(List<QywxExternalMessageBaseDTO> attachments, String enterpriseId, String wxEnterpriseId, String relationKey) {
        if (StringUtils.isEmpty(enterpriseId) || StringUtils.isEmpty(relationKey)) {
            log.info("带参二维码无法发送");
            return;
        }
        log.info("发送带参小程序：wxEnterpriseId:{}", wxEnterpriseId);
        //发送小程序
        TabMiniprogramSetting miniprogramSetting = miniprogramSettingService.getMiniprogramSetting(wxEnterpriseId, enterpriseId);
        if (null == miniprogramSetting) {
            log.info("需要配置小程序配置：wxEnterpriseId:{},enterpriseId:{}", wxEnterpriseId, enterpriseId);
            return;
        }
        QywxMiniprogramExternalBaseDTO messageBaseDTO = new QywxMiniprogramExternalBaseDTO();
        messageBaseDTO.setAppid(miniprogramSetting.getAppId());
        messageBaseDTO.setPicMediaId(miniprogramSetting.getMediaId());
        messageBaseDTO.setTitle(miniprogramSetting.getTitle());
        messageBaseDTO.setPage(config.getMemberOpenPage() + relationKey);
        attachments.add(messageBaseDTO);
    }

    private void attachmentAddParamQrCode(List<QywxExternalMessageBaseDTO> attachments, String enterpriseId, String clerkId,
                                          String corpid, String relationKey) {
        if (StringUtils.isEmpty(enterpriseId) || StringUtils.isEmpty(clerkId)) {
            log.info("带参小程序无法发送");
            return;
        }
        //带参数的公众号二维码
        String sceneStr = "QWHY_" + relationKey + "_" + clerkId;
        //30天失效
        QRcodeDTO qRcodePic = imageService.getQRcodePic(enterpriseId, sceneStr, 2592000);
        log.info("参数的公众号二维码返回：{}", JSON.toJSONString(qRcodePic));
        if (qRcodePic != null) {
            String downloadUrl = qRcodePic.getPicUploadResDTO().downloadUrl;
            String[] arr = downloadUrl.split("/");
            JSONResponse jp = qywxSuiteApiService.uploadMedia(
                    corpid,
                    config.getWxSuiteid(),
                    CommonUtil.getFileByte(downloadUrl),
                    arr[arr.length - 1],
                    QywxMediaTypeEnum.IMAGE.getCode());
            log.info("欢迎语发送带参数的公众号企微二维码返回：{}", JSON.toJSONString(jp));
            if (jp.getErrorCode() == 0) {
                QywxImageExternalBaseDTO qywxImageExternalBaseDTO = new QywxImageExternalBaseDTO();
                qywxImageExternalBaseDTO.setMediaId(jp.getResult().toString());
                attachments.add(qywxImageExternalBaseDTO);
            }
        }
    }


    /**
     * 组装数据
     *
     * @param dto
     * @return
     */
    public MemberUnionidRelatedDTO getMemberUnionidRelatedDTONew(MemberUnionidRelatedDTO dto, String wxUserId) {
        log.info("【新增外部联系人回调】dto={}", JSON.toJSONString(dto));
        String corpId = dto.getCorpid();
        TabHaobanWxApplication tabHaobanWxApplication = wxApplicationMapper.selectByCorpId(corpId, null);
        if (tabHaobanWxApplication == null) {
            log.info("查询tab_haoban_wx_application为空：{}", corpId);
            return null;
        }
        String wxEnterpriseId = tabHaobanWxApplication.getWxEnterpriseId();
        String suiteid = dto.getSuiteid();
        String externalUserid = dto.getExternalUserid();
        ExternalUserDTO externalUserDTO;
        if (SELF_APP.equals(suiteid)) {
            externalUserDTO = this.getCorpSelfExternalUseridInfo(wxEnterpriseId, wxUserId, externalUserid);
        } else {
            externalUserDTO = this.getExternalUseridInfo(wxEnterpriseId, wxUserId, externalUserid);
        }
        checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId, externalUserDTO, dto);
        if (externalUserDTO == null) {
            log.info("【新增外部联系人回调】失败,查询好友信息失败");
            return null;
        }
        dto.setWxEnterpriseId(wxEnterpriseId);
        dto.setExternalName(EmojiFilterUtil.removeAllEmoji(externalUserDTO.getName()));
        dto.setAddCreateTime(externalUserDTO.getAddCreateTime());
        dto.setAvatar(externalUserDTO.getAvatar());
        if (SELF_APP.equals(suiteid)) {
            dto.setUnionid(externalUserDTO.getUnionId());
            dto.setSelfExternalUserid(externalUserDTO.getExternalUserId());
            dto.setExternalUserid(null);
            dto.setAvatar(externalUserDTO.getAvatar());
        } else {
            dto.setExternalUserid(externalUserDTO.getExternalUserId());
        }

        String key = "external" + dto.getWxEnterpriseId() + "_" + dto.getExternalName() + "_" + dto.getAddCreateTime();
        String lockKey = key + "-lock";
        RedisUtil.lock(lockKey, 10L);

        MemberUnionidRelatedDTO midRelatedDto = RedisUtil.getCache(key, MemberUnionidRelatedDTO.class);
        if (midRelatedDto == null) {
            log.info("redis缓存中无该好友数据,插入数据：{}", JSON.toJSONString(dto));
            String memberUnionidRelatedId = memberUnionRelatedService.addMemberUnionidRelated(dto);
            dto.setMemberUnionidRelatedId(memberUnionidRelatedId);
            RedisUtil.setCache(key, dto, 180L);
            RedisUtil.unlock(lockKey);
            return null;
        }

        dto.setUnionid(StringUtils.isBlank(dto.getUnionid()) ? midRelatedDto.getUnionid() : dto.getUnionid());
        dto.setExternalUserid(StringUtils.isBlank(dto.getExternalUserid()) ? midRelatedDto.getExternalUserid() : externalUserid);
        dto.setSelfExternalUserid(StringUtils.isBlank(dto.getSelfExternalUserid()) ? midRelatedDto.getSelfExternalUserid() : dto.getSelfExternalUserid());
        dto.setAvatar(StringUtils.isBlank(dto.getAvatar()) ? midRelatedDto.getAvatar() : dto.getAvatar());
        dto.setMemberUnionidRelatedId(midRelatedDto.getMemberUnionidRelatedId());

        if (StringUtils.isAnyBlank(dto.getExternalUserid(), dto.getSelfExternalUserid())) {
            log.error("加好友异常、请检查配置是否正常(如：检查客户联系回调、老好办助手回调、代开发回调（是否配置多个回调、企微权限是否正常、密钥是否正确）、好办权限等)，wxEnterpriseId：{}", wxEnterpriseId);
            return null;
        }

        log.info("好办和好办助手均已回调：{}", JSON.toJSONString(dto));
        List<MemberUnionidRelatedDTO> relatedDTOS = memberUnionRelatedService.listBySelfExternalUserId(dto.getStaffId(), dto.getWxEnterpriseId(), dto.getSelfExternalUserid());
        //老的关联需要删除
        if (CollectionUtils.isNotEmpty(relatedDTOS)) {
            relatedDTOS.stream().filter(mid -> (!mid.getMemberUnionidRelatedId().equals(midRelatedDto.getMemberUnionidRelatedId())))
                    .forEach(mid -> {
                        mid.setStatusFlag(0);
                        memberUnionRelatedService.update(mid);
                    });
        }
        memberUnionRelatedService.update(dto);
        RedisUtil.unlock(lockKey);
        RedisUtil.delCache(key);
        return dto;
    }


    private ExternalUserPojo getExternalUserPojo(String unionIdJson, String userId1, String wxEnterpriseId) {
        ExternalUserPojo pojo = new ExternalUserPojo();
        String unionId = "";
        String follow_user = "";
        String createTime = "";
        String userId = "";
        String avatar = "";
        String relaName = "";
        String externalUserId = "";
        String state = "";
        if (StringUtils.isNotBlank(unionIdJson)) {
            JSONObject jo = JSON.parseObject(unionIdJson);
            String external_contact = jo.getString("external_contact");
            if (StringUtils.isNotBlank(external_contact)) {
                JSONObject jt = JSON.parseObject(external_contact);
                unionId = jt.getString("unionid");
                relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(relaName)) {
                    relaName = "--";
                }
                avatar = jt.getString("avatar");
                externalUserId = jt.getString("external_userid");
            }

            follow_user = jo.getString("follow_user");
            if (StringUtils.isNotBlank(follow_user)) {
                JSONArray j = JSON.parseArray(follow_user);
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    userId = follow.getString("userid");
                    state = follow.getString("state");
                    if (userId.equals(userId1)) {
                        createTime = follow.getString("createtime");
                    }
                }
            }
        }
        pojo.setAddCreateTime(createTime);
        pojo.setAvatar(avatar);
        pojo.setName(relaName);
        pojo.setUnionId(unionId);
        pojo.setExternalUserId(externalUserId);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setState(state);
        return pojo;
    }

    @Override
    public void delMemberUnionidRelated(QwFrientNoticeDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.del.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    @Override
    public void editMemberUnionidRelated(QwFrientNoticeDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.edit.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    /**
     * 删除好友
     *
     * @param dto
     */
    private void delMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto , String wxUserId) {
        String corpId = dto.getCorpid();
        TabHaobanWxApplication tabHaobanWxApplication = wxApplicationMapper.selectByCorpId(corpId, null);
        if (tabHaobanWxApplication == null) {
            log.info("查询tab_haoban_wx_application为空：{}", corpId);
            return ;
        }
        String wxEnterpriseId = tabHaobanWxApplication.getWxEnterpriseId();
        dto.setWxEnterpriseId(wxEnterpriseId);
        TabHaobanStaff staff =  this.staffMapper.selectByUserIdAndEnterpriseId(wxUserId,wxEnterpriseId) ;
        String staffId = staff.getStaffId() ;
        dto.setStaffId(staffId);
        externalClerkRelatedService.delByUserIdAndExternalUserId(dto , wxUserId);
        memberUnionRelatedService.delMemberUnionidRelated(dto , staffId);
    }

    private void editMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto, String wxUserId) {
        log.info("修改标签/会员信息回调：{}", JSONObject.toJSONString(dto));
        TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(dto.getCorpid());
        if (null == wxEnterprise) {
            return;
        }
        if (dto.getSuiteid().equals(SELF_APP)) {
            log.info("self不执行");
            return;
        }
        pushTagSync(dto.getExternalUserid(), wxUserId
                , GicQywxSyncTypeEnum.FRIEND_TAG_SYNC.getType(), QywxSyncTaskTypeEnum.MEMBER_SYNC.getType(), wxEnterprise.getWxEnterpriseId(), null);
    }

    @Override
    public ExternalClerkRelatedDTO getByMemberId(String staffId, String memberId) {
        log.info("【查询会员】wxUserId={},memberId={}", staffId, memberId);
        return externalClerkRelatedService.getByMemberId(staffId, memberId);
    }

    @Override
    public void cleanByCid(String cid) {
        if (StringUtils.isNotBlank(cid)) {
            TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(cid);
            if (null != wxEnterprise) {
                memberUnionRelatedService.clean(wxEnterprise.getWxEnterpriseId());
            }
        } else {
            memberUnionRelatedService.clean(null);
        }
    }

    /**
     * 老的单个素材群发的api
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialId     : 素材id
     * @return : 返回群发执行结果
     */
    @Override
    public String sendMessage(String wxEnterpriseId, String staffId, List<String> extendUserList, String materialId) {
        JSONResponse jp = this.sendMessage(wxEnterpriseId, staffId, extendUserList, Collections.singletonList(materialId));
        //返回执行结果, msgId
        log.info("【发送消息】jp = {}", JSON.toJSONString(jp));
        Map<String, Object> returnMap = jp.getReturnMap();
        return returnMap.get("msgid") == null ? "" : returnMap.get("msgid").toString();
    }

    /**
     * 创建企业群发, 支出素材批量发送
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialIdList : 素材id列表
     * @return : 返回群发执行结果
     */
    @Override
    public JSONResponse sendMessage(String wxEnterpriseId, String staffId, List<String> extendUserList, List<String> materialIdList) {
        //群发请求参数
        QywxExternalMessageDTO qywxExternalMessageDTO = new QywxExternalMessageDTO();
        //素材列表
        List<QywxMessageMaterialDTO> messageMaterialList = new ArrayList<>();
        materialIdList.forEach(materialId -> {
            MaterialDTO material = materialApiService.getHasChangeMadieMaterialById(materialId);
            if (material == null) {
                return;
            }
            if (material.getMaterialType() == 1) {
                qywxExternalMessageDTO.setContent(material.getMaterialContent());
            } else {
                messageMaterialList.add(this.getMessageMaterial(material));
            }
        });
        //素材列表不存在, 并且不存在文本内容, 不执行
        if (messageMaterialList.isEmpty() && StringUtils.isBlank(qywxExternalMessageDTO.getContent())) {
            JSONResponse jp = new JSONResponse();
            jp.setErrorCode(-1);
            jp.setErrorMessage("群发素材不存在, 群发创建失败");
            return jp;
        }
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        //请求参数赋值
        qywxExternalMessageDTO.setChatType("single");
        qywxExternalMessageDTO.setExternalUserid(extendUserList);
        TabHaobanStaff tabHaobanStaff = staffService.selectById(staffId);
        if (qwDTO.needOpenUserId3th()) {
            qywxExternalMessageDTO.setSenderUserId(tabHaobanStaff.getWxOpenUseId());
        } else {
            qywxExternalMessageDTO.setSenderUserId(tabHaobanStaff.getWxUserId());
        }
        qywxExternalMessageDTO.setAttachments(messageMaterialList);
        //调接口执行创建群发
        return qywxSuiteApiService.sendExternalMessage(qwDTO.getThirdCorpid(), config.getWxSuiteid(), qywxExternalMessageDTO);
    }

    /**
     * 素材发送对象构造
     *
     * @param material : 素材对象
     * @return : 返回素材发送对象
     */
    private QywxMessageMaterialDTO getMessageMaterial(MaterialDTO material) {
        //素材类型
        Integer materialType = material.getMaterialType();
        //主键id
        String materialId = material.getMaterialId();
        //企微对应的id
        String maerialId = material.getMediaId();
        //判断素材企微id是否需要刷新
        List<Integer> materialTypeList = Arrays.asList(2, 4, 6);
        if (materialTypeList.contains(materialType)) {
            Date wxLastTime = material.getWxLastUploadTime();
            if (DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()) {
                maerialId = materialApiService.reUpdalodMetail(materialId);
            }
        }
        //素材对象
        QywxMessageMaterialDTO dto = new QywxMessageMaterialDTO();
        if (materialType == 2) {
            QywxImageMaterialDTO imageMaterialDTO = new QywxImageMaterialDTO();
            imageMaterialDTO.setMediaId(maerialId);
            dto.setMsgType(QywxMediaTypeEnum.IMAGE.getName());
            dto.setImage(imageMaterialDTO);
        } else if (materialType == 3) {
            QywxLinkMaterialDTO linkMaterialDTO = new QywxLinkMaterialDTO();
            linkMaterialDTO.setTitle(material.getMaterialTitle());
            linkMaterialDTO.setPicUrl(material.getWxImgUrl());
            linkMaterialDTO.setDesc(material.getMaterialDesc());
            linkMaterialDTO.setUrl(material.getLink());
            dto.setMsgType(QywxMediaTypeEnum.LINK.getName());
            dto.setLink(linkMaterialDTO);
        } else if (materialType == 4) {
            QywxVideoMaterialDTO videoMaterialDTO = new QywxVideoMaterialDTO();
            videoMaterialDTO.setMediaId(maerialId);
            dto.setMsgType(QywxMediaTypeEnum.VIDEO.getName());
            dto.setVideo(videoMaterialDTO);
        } else if (materialType == 6) {
            QywxMiniprogramMaterialDTO miniprogramMaterialDTO = new QywxMiniprogramMaterialDTO();
            miniprogramMaterialDTO.setTitle(material.getMaterialTitle());
            miniprogramMaterialDTO.setPicMediaId(maerialId);
            miniprogramMaterialDTO.setAppid(material.getAppId());
            miniprogramMaterialDTO.setPage(material.getLink());
            dto.setMsgType(QywxMediaTypeEnum.MINIPROGRAM.getName());
            dto.setMiniprogram(miniprogramMaterialDTO);
        }
        return dto;
    }

    /**
     * 获取群发成员发送任务列表
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse taskExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            return null;
        }
        return qywxSuiteApiService.taskExternalMessage(qwDTO.getThirdCorpid(), config.getWxSuiteid(), wxMessageId, cursor);
    }

    /**
     * 获取企业群发成员执行结果
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @param userId         : 用户id
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse resultExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor, String userId) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            return null;
        }
        return qywxSuiteApiService.resultExternalMessage(qwDTO.getThirdCorpid(), config.getWxSuiteid(), wxMessageId, cursor, userId);
    }

    @Override
    public JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            return null;
        }
        return qywxSuiteApiService.resultExternalMessage(qwDTO.getThirdCorpid(), config.getWxSuiteid(), wxMessageId);
    }

    @Override
    public List<String> listSelfExterialList(String wxEnterpriseId, String wxUserId) {
        try {
            log.info("【查询代开应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
            WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
            List<String> list = new ArrayList<>();
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CUSTOMIZED_APP.getVal());
            if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
                log.info("没有配置客户联系secret:{}", wxEnterpriseId);
                return list;
            }
            String res = qywxUserApiService.listSelfExternalUserid(qwDTO.getDkCorpid(), secretSetting.getSecretVal(), wxUserId);
            log.info("【查询自建应用】res={}", res);
            if (res != null && res.equals("1")) {
                log.info("代表需要重试");
                return null;
            }
            if (StringUtils.isBlank(res)) {
                return list;
            }
            JSONArray jsonArr = JSON.parseArray(res);
            if (jsonArr.size() == 0) {
                return list;
            }
            for (Object object : jsonArr) {
                list.add(object.toString());
            }
            return list;
        } catch (Exception e) {
            log.info("错误={}", e);
        }
        return null;
    }

    @Override
    public List<String> listExterialList(String wxEnterpriseId, String wxUserId) {
        log.info("【获取第三方应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        String corpid = qwDTO.getThirdCorpid();
        String userId = "";
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            log.error("员工为空，wxUserId：{}", wxUserId);
            return null;
        }
        if (qwDTO.needOpenUserId3th()) {
            userId = staff.getWxOpenUseId();
        } else {
            userId = staff.getWxUserId();
        }
        log.info("【获取第三方应用好友】wxEnterpriseId={},userId={}", wxEnterpriseId, userId);
        String wxRes = qywxUserApiService.listExternalUserid(corpid, config.getWxSuiteid(), userId);
        List<String> list = new ArrayList<>();
        log.info("【查询第三方应用】res={}", wxRes);
        if ("1".equals(wxRes)) {
            log.info("代表需要重试");
            return null;
        }
        if (StringUtils.isBlank(wxRes)) {
            return list;
        }
        JSONArray jsonArr = JSON.parseArray(wxRes);
        if (jsonArr.size() == 0) {
            return list;
        }
        for (Object object : jsonArr) {
            list.add(object.toString());
        }
        return list;
    }

    @Override
    public ExternalUserDTO getCorpSelfExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            log.info("企业不存在");
            return null;
        }
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CUSTOMIZED_APP.getVal());
        if (null == secretSetting) {
            log.info("没有配置secret");
            return null;
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(qwDTO.getDkCorpid(), secretSetting.getSecretVal(), externalUserId);
        if (StringUtils.isBlank(unionIdJson)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(unionIdJson)) {
            log.info("接口调用被限制");
            throw new WxApiLimitException("getCorpSelfExternalUseridInfo接口调用被限制");
        }
        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, wxUserId, wxEnterpriseId);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }
    
    @Override
    public ExternalUserDTO getCorpSelfExternalUseridInfoForMember(String wxEnterpriseId, String wxUserId,
            String externalUserId,String enterpriseId) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            log.info("企业不存在");
            return null;
        }
        SecretSettingDTO secretSetting = secretSettingService.getMemberSecretSetting(wxEnterpriseId, enterpriseId);
        if (null == secretSetting) {
            log.info("没有配置secret");
            return null;
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(qwDTO.getMemberCorpid(), secretSetting.getSecretVal(), externalUserId);
        if (StringUtils.isBlank(unionIdJson)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(unionIdJson)) {
            log.info("接口调用被限制");
            throw new WxApiLimitException("getCorpSelfExternalUseridInfo接口调用被限制");
        }
        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, wxUserId, wxEnterpriseId);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public ExternalUserDTO getExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        log.info("查询第三方:wxEnterpriseId:{},wxUserId:{},externalUserId:{}", wxEnterpriseId, wxUserId, externalUserId);
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            log.info("企业不存在");
            return null;
        }
        TabHaobanStaff tabHaobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (tabHaobanStaff == null) {
            log.info("员工不存在，wxUserId：{}", wxUserId);
            return null;
        }
        String wxOpenUseId = tabHaobanStaff.getWxOpenUseId();
        String uJ = qywxUserApiService.getExternalUseridInfo(qwDTO.getThirdCorpid(), config.getWxSuiteid(), externalUserId);
        if (StringUtils.isBlank(uJ)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(uJ)) {
            log.info("限制次数");
            throw new WxApiLimitException("getExternalUseridInfo接口次数限制");
        }
        String name = "";
        String createTime = "";
        String avatar = "";
        Integer friendType = 1;
        String state = "";
        if (StringUtils.isNotBlank(uJ)) {
            JSONObject jo = JSON.parseObject(uJ);
            String external_contact = jo.getString("external_contact");
            String uj_follow_user = jo.getString("follow_user");
            JSONObject jt = null;
            if (StringUtils.isNotBlank(external_contact)) {
                jt = JSON.parseObject(external_contact);
                name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(name)) {
                    name = "--";
                }
                friendType = jt.getInteger("type");
                avatar = jt.getString("avatar");
            }
            if (StringUtils.isNotBlank(uj_follow_user)) {
                JSONArray j = JSON.parseArray(uj_follow_user);
                String uj_userId = "";
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    uj_userId = follow.getString("userid");
                    state = follow.getString("state");
                    //第三方返回的是加密的，多做一层判断
                    if (uj_userId.equals(wxUserId) || uj_userId.equals(wxOpenUseId)) {
                        if (jt != null) {
                            externalUserId = jt.getString("external_userid");
                            createTime = follow.getString("createtime");
                            break;
                        }
                    }
                }
            }
        }
        ExternalUserPojo pojo = new ExternalUserPojo();
        pojo.setExternalUserId(externalUserId);
        pojo.setName(name);
        pojo.setAddCreateTime(createTime);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setAvatar(avatar);
        pojo.setFriendType(friendType);
        pojo.setState(state);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public String addExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String unionId = dto.getUnionId();
        String externalUserId = dto.getExternalUserId();
        String memberId = dto.getMemberId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},unionId ={},externalUserId ={},memberId ={},storeId ={},enterpriseId ={},staffId={},clerkId={}"
                    + "", wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId);
            return "参数不对";
        }
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByWxUserIdAndUnionId(wxEnterpriseId, staffId, unionId);
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setStaffId(staffId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setMemberId(memberId);
            exsitDTO.setEnterpriseId(enterpriseId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setExternalName(name);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setMemberId(memberId);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setStaffId(staffId);
            memberUnionRelatedService.update(exsitDTO);
        }
        String relationKey = SecureUtil.md5(staffId + externalUserId);
        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserId, staffId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setRelationKey(relationKey);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setMemberId(memberId);
            related.setHeadUrl(dto.getAvatar());
            related.setStatusFlag(1);
            externalClerkRelatedService.insert(related);
        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberId(memberId);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setRelationKey(relationKey);
            external.setUnionid(unionId);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setHeadUrl(dto.getAvatar());
            external.setStatusFlag(1);
            externalClerkRelatedService.update(external);
        }
        //同步标签
        pushTagSync(memberId, wxEnterpriseId, enterpriseId);

        //通知企微好友
        log.info("通知会员 更新为企微好友 memberId:{}", memberId);
        memberApiService.updateMemberQywxFlag(enterpriseId, memberId, 1);
        return "";
    }

    /**
     * 同步
     *
     * @param wxEnterpriseId
     * @param enterpriseId
     */
    private void pushTagSync(String dataId, String taskId, int syncType, int taskType, String wxEnterpriseId, String enterpriseId) {
        QywxTagSyncInfoPojo pojo = new QywxTagSyncInfoPojo();
        pojo.setDataId(dataId);
        pojo.setTaskId(taskId);
        pojo.setTaskType(taskType);
        //单个会员同步
        pojo.setSyncType(syncType);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setEnterpriseId(enterpriseId);
        GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
        try {
            clientInstance.sendMessage("qywxTagSyncDeal", JSONObject.toJSONString(pojo));
        } catch (Exception e) {
            log.info("异常：{}", e);
        }
    }

    /**
     * 同步
     *
     * @param memberId
     * @param wxEnterpriseId
     * @param enterpriseId
     */
    private void pushTagSync(String memberId, String wxEnterpriseId, String enterpriseId) {
        this.pushTagSync(memberId, "-1", GicQywxSyncTypeEnum.SINGLE_WXENT_MEMNER_SYNC.getType(), QywxSyncTaskTypeEnum.MEMBER_SYNC.getType(), wxEnterpriseId, enterpriseId);
    }

    @Override
    public String addFriendExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        String selfExternalUserId = dto.getSelfExternalUserId();
        if (StringUtils.isAnyBlank(wxUserId, selfExternalUserId, wxEnterpriseId, name, createTime, externalUserId, storeId, enterpriseId, staffId, clerkId)) {
            log.error("参数不对：{}", JSON.toJSONString(dto));
            return "参数不对";
        }
        String relationKey = SecureUtil.md5(staffId + externalUserId);
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByWxUserIdAndSelfExternalUserId(staffId, wxEnterpriseId, dto.getSelfExternalUserId());
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setStaffId(staffId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setExternalName(name);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setStaffId(staffId);
            memberUnionRelatedService.update(exsitDTO);
        }

        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(wxEnterpriseId, externalUserId, staffId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setStatusFlag(3);
            related.setHeadUrl(dto.getAvatar());
            related.setRelationKey(relationKey);
            externalClerkRelatedService.insert(related);
        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setHeadUrl(dto.getAvatar());
            external.setRelationKey(relationKey);
            external.setStatusFlag(external.getStatusFlag() == 1 ? 1 : external.getStatusFlag());
            externalClerkRelatedService.update(external);
        }
        return "";
    }

    @Override
    public void cleanNoExsitFriendNew(String wxEnterpriseId, String staffId, List<String> externalUserIds) {
        log.info("开始删除无效的外部联系人,wxEnterpriseId={},staffId={}", wxEnterpriseId, staffId);
        //查询所有的外部联系人
        List<TabHaobanExternalClerkRelated> list = externalClerkRelatedMapper.getByWxUserIdAndWxEnterpriseId(wxEnterpriseId, staffId);
        if (CollectionUtils.isEmpty(list)) {
            log.info("导购下没有外部联系人，无需处理,{}", staffId);
            return;
        }
        Set<String> externalUserIdList = list.stream().map(external -> external.getExternalUserId()).collect(Collectors.toSet());
        Sets.SetView<String> delExternalUserIds = Sets.difference(new HashSet<>(externalUserIds), externalUserIdList);
        if (CollectionUtils.isEmpty(delExternalUserIds)) {
            log.info("没有需要删除的外部联系人:{},{}", staffId);
            return;
        }
        //删除成员与union的关联关系
        List<String> khList = new ArrayList<String>(delExternalUserIds) ;
        log.info("需要删除外部联系人staffId={} , khList={}", staffId,JSON.toJSONString(khList));
        memberUnionRelatedService.delMemberUnionidRelatedBatch(wxEnterpriseId, staffId, khList);
        //删除导购和外部联系人关系
        externalClerkRelatedService.delByUserIdAndExternalUserIdBatch(wxEnterpriseId, staffId, khList);
    }

    @Override
    public ServiceResponse<List<FriendStoreInfoDTO>> listFriendClerkByMemberUnionid(String enterpriseId, String unionId) {
        ServiceResponse<List<FriendStoreInfoDTO>> resp = new ServiceResponse<>();
        if (StringUtils.isAnyBlank(enterpriseId, unionId)) {
            resp.setMessage("参数有误");
            resp.setCode(2);
            return resp;
        }
        List<TabHaobanExternalClerkRelated> relateds = externalClerkRelatedService.listExternalByUnionId(enterpriseId, unionId);
        if (CollectionUtils.isEmpty(relateds)) {
            return resp;
        }
        //导购信息
        Set<String> clerkIds = relateds.stream().map(dto -> dto.getClerkId()).collect(Collectors.toSet());
        log.info("获取clerkIds：{}", JSONObject.toJSONString(clerkIds));
        List<ClerkDTO> clerkDTOS = clerkService.getClerkByIds(clerkIds);
        if (CollectionUtils.isEmpty(clerkDTOS)) {
            log.info("没有有效的导购");
            return resp;
        }
        Map<String, ClerkDTO> clerkMap = clerkDTOS.stream().collect(Collectors.toMap(ClerkDTO::getClerkId, dto -> dto));

        //门店信息
        List<String> storeIds = relateds.stream().map(dto -> dto.getStoreId()).collect(Collectors.toList());
        log.info("门店storeIds：{}", JSONObject.toJSONString(storeIds));
        List<StoreDTO> storeDTOS = storeService.queryStore(storeIds);
        if (CollectionUtils.isEmpty(storeDTOS)) {
            log.info("没有关联的门店");
            return resp;
        }
        Map<String, StoreDTO> storeMap = storeDTOS.stream().collect(Collectors.toMap(StoreDTO::getStoreId, dto -> dto));

        //组装
        log.info("组装返回的好友导购信息:{}", unionId);
        List<FriendStoreInfoDTO> ret = relateds.stream().map(related -> {
            ClerkDTO clerkDTO = clerkMap.get(related.getClerkId());
            StoreDTO storeDTO = storeMap.get(related.getStoreId());

            FriendStoreInfoDTO friendStoreInfoDTO = new FriendStoreInfoDTO();
            friendStoreInfoDTO.setAddFriendTime(related.getAddCreateTime());
            friendStoreInfoDTO.setClerkId(related.getClerkId());
            friendStoreInfoDTO.setStoreId(related.getStoreId());
            friendStoreInfoDTO.setWxUserId(null/*related.getWxUserId()*/);
            friendStoreInfoDTO.setStoreCode(storeDTO != null ? storeDTO.getStoreCode() : null);
            friendStoreInfoDTO.setStoreName(storeDTO != null ? storeDTO.getStoreName() : null);
            friendStoreInfoDTO.setClerkCode(clerkDTO != null ? clerkDTO.getClerkCode() : null);
            friendStoreInfoDTO.setClerkName(clerkDTO != null ? clerkDTO.getClerkName() : null);
            friendStoreInfoDTO.setClerkPhoneNumber(clerkDTO != null ? clerkDTO.getPhoneNumber() : null);
            return friendStoreInfoDTO;
        }).collect(Collectors.toList());
        resp.setResult(ret);
        return resp;
    }

    @Override
    public MemberUnionidRelatedDTO getBySelfExternalUserId(String wxEnterpriseId, String selfExternalUserId) {
        return memberUnionRelatedService.getBySelfExternalUserId(wxEnterpriseId, selfExternalUserId);
    }

    @Override
    public void addMemberUnionidWechatAccount(String res) {
        log.info("通过查询unionid关联导购对外联系人id接口,res:{}", res);
        if (StringUtils.isBlank(res)) {
            log.info("通过查询unionid关联导购对外联系人id接口为空");
            return;
        }
        MemberUnionidWechatAccountQDTO memberUnionidWechatAccountQDTO = JSON.parseObject(res, MemberUnionidWechatAccountQDTO.class);
        String enterpriseId = memberUnionidWechatAccountQDTO.getEnterpriseId();
        String unionid = memberUnionidWechatAccountQDTO.getUnionid();
        String openId = memberUnionidWechatAccountQDTO.getOpenId();
        String memberId = memberUnionidWechatAccountQDTO.getMemberId();
        if (StringUtils.isAnyBlank(enterpriseId, unionid, openId, memberId)) {
            log.error("关注公共号-会员回调好办关联好友 有参数为空:enterpriseId:{},unionid:{},openId:{},memberId:{}", enterpriseId, unionid, openId, memberId);
            return;
        }
        List<TabHaobanWxEnterprise> tabHaobanWxEnterprises = wxEnterpriseRelatedService.listByEnterpriseId(enterpriseId);
        if (CollectionUtils.isEmpty(tabHaobanWxEnterprises)) {
            log.error("企业为空");
            return;
        }

        RRateLimiter rateLimiter = RedisUtil.getRedisClient().getRateLimiter("member:weChat:add:limit");
        // 每1小时产生9500个令牌
        rateLimiter.trySetRate(RateType.OVERALL, 9500, 1, RateIntervalUnit.HOURS);
        for (TabHaobanWxEnterprise tabHaobanWxEnterpris : tabHaobanWxEnterprises) {
            if (!rateLimiter.tryAcquire()) {
                log.error("请求unionidToExternalUserid3rd超过限制，丢入消息队列，重新消费");
                GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
                try {
                    clientInstance.sendMessage("addMemberUnionidWechatAccountMq", res, 60 * 60);
                } catch (Exception e) {
                    log.info("addMemberUnionidWechatAccount 发送失败：{}", e.getMessage(), e);
                }
                return;
            }
            String wxEnterpriseId = tabHaobanWxEnterpris.getWxEnterpriseId();
            WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
            String corpid = qwDTO.getThirdCorpid();
            List<UnionidToExternalUseridDTO> unionidToExternalUseridDTOS = qywxUserApiService.unionidToExternalUserid3rd(unionid, openId, corpid, config.getWxSuiteid());
            if (CollectionUtils.isEmpty(unionidToExternalUseridDTOS)) {
                log.error("请求unionidToExternalUserid3rd返回为空");
                continue;
            }

            for (UnionidToExternalUseridDTO unionidToExternalUseridDTO : unionidToExternalUseridDTOS) {
                String externalUserid = unionidToExternalUseridDTO.getExternalUserid();
                List<ExternalUserDTO> externalUseridInfoList = getExternalUseridInfoList(wxEnterpriseId, externalUserid);
                if (CollectionUtils.isEmpty(externalUseridInfoList)) {
                    log.error("返回客户详情为空：wxEnterpriseId:{},externalUserid:{}", wxEnterpriseId, externalUserid);
                    break;
                }
                for (ExternalUserDTO externalUserDTO : externalUseridInfoList) {
                    String wxUserId = externalUserDTO.getWxUserId();
                    TabHaobanStaff tabHaobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
                    if (tabHaobanStaff == null) {
                        log.error("员工不存在:{}",wxUserId);
                        continue;
                    }
                    TabHaobanExternalClerkRelated externalClerkRelated = externalClerkRelatedMapper.getByEnterpriseIdAndExternalUserId(wxEnterpriseId, tabHaobanStaff.getStaffId(), enterpriseId, externalUserid);
                    if (externalClerkRelated == null) {
                        log.info("查询不到好友wxEnterpriseId:{}, wxUserId:{}, enterpriseId:{}, externalUserid:{}", wxEnterpriseId, tabHaobanStaff.getStaffId(), enterpriseId, externalUserid);
                        continue;
                    }
                    boolean flag = externalClerkRelatedApiService.bindMemberIdExternalById(externalClerkRelated.getExternalClerkRelatedId(), enterpriseId, memberId, unionid);
                    if (flag) {
                        //调用会员接口来自企微
                        memberStoreService.saveMemberStoreClerkRelation(memberId, externalClerkRelated.getStoreId(), externalClerkRelated.getClerkId(), "企微好友");
                    }
                }
            }
        }
    }

    @Override
    public void addMemberUnionidWechatAccountByClerk(String res) {
        log.info("关注公共号-会员回调好办关联好友请求参数：{}", res);
        if (StringUtils.isBlank(res)) {
            log.info("关注公共号-会员回调好办关联好友请求参数为空");
            return;
        }
        MemberUnionidWechatAccountQDTO memberUnionidWechatAccountQDTO = JSON.parseObject(res, MemberUnionidWechatAccountQDTO.class);
        String enterpriseId = memberUnionidWechatAccountQDTO.getEnterpriseId();
        String unionid = memberUnionidWechatAccountQDTO.getUnionid();
        String openId = memberUnionidWechatAccountQDTO.getOpenId();
        String memberId = memberUnionidWechatAccountQDTO.getMemberId();
        String sceneStr = memberUnionidWechatAccountQDTO.getSceneStr();
        if (StringUtils.isAnyBlank(enterpriseId, unionid, openId, memberId, sceneStr)) {
            log.error("关注公共号-会员回调好办关联好友，有参数为空:enterpriseId:{},unionid:{},openId:{},memberId:{},sceneStr:{}", enterpriseId, unionid, openId, memberId, sceneStr);
            return;
        }
        String[] s = sceneStr.split("_");
        String relationKey = s[1];
        TabHaobanExternalClerkRelated externalClerkRelated = externalClerkRelatedMapper.getByRelationKey(relationKey);
        if (externalClerkRelated == null) {
            log.error("关注公共号-会员回调好办关联好友,未查询到,relationKey：{}", relationKey);
            //重试5次
            Integer currentTimes = Convert.toInt(RedisUtil.getCache(relationKey), 0);
            if (currentTimes > MAX_TIMES) {
                log.error("关注公共号-会员回调好办关联好友重试超过最大次数，relationKey：{}", relationKey);
                return;
            }
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                clientInstance.sendMessage("addMemberUnionidWechatAccountByClerkMq", res, 180);
                RedisUtil.setCache(relationKey, currentTimes + 1, 2L, TimeUnit.HOURS);
            } catch (Exception e) {
                log.info("发送消息异常：{}", e.getMessage());
            }
            return;
        }
        externalClerkRelatedApiService.bindMemberIdExternalById(externalClerkRelated.getExternalClerkRelatedId(), enterpriseId, memberId, unionid);
    }

    @Override
    public void updateSelfExternalUseridById(String selfExternalUserid, String memberUnionidRelatedId) {
        MemberUnionidRelatedDTO relatedDTO = new MemberUnionidRelatedDTO();
        relatedDTO.setMemberUnionidRelatedId(memberUnionidRelatedId);
        relatedDTO.setSelfExternalUserid(selfExternalUserid);
        memberUnionRelatedService.update(relatedDTO);
    }

    @Override
    public MemberUnionidRelatedDTO getById(String memberUnionidRelatedId) {
        MemberUnionidRelated memberUnionidRelated = memberUnionidRelatedMapper.selectByPrimaryKey(memberUnionidRelatedId);
        return EntityUtil.changeEntityNew(MemberUnionidRelatedDTO.class, memberUnionidRelated);
    }
  
    /**
     * 获取客户详情列表
     *
     * @param wxEnterpriseId
     * @param externalUserId
     * @return
     */
    private List<ExternalUserDTO> getExternalUseridInfoList(String wxEnterpriseId, String externalUserId) {
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            log.info("企业不存在");
            return null;
        }
        String uJ = qywxUserApiService.getExternalUseridInfo(qwDTO.getThirdCorpid(), config.getWxSuiteid(), externalUserId);
        if (StringUtils.isBlank(uJ)) {
            log.info("好友不存在");
            return null;
        } else if ("1".equals(uJ)) {
            log.info("限制次数");
            throw new WxApiLimitException("getExternalUseridInfo接口次数限制");
        }
        String name = "";
        String createTime = "";
        String avatar = "";
        Integer friendType = 1;
        List<ExternalUserPojo> externalUserPojoList = new ArrayList<>();
        JSONObject jo = JSON.parseObject(uJ);
        String external_contact = jo.getString("external_contact");
        String uj_follow_user = jo.getString("follow_user");
        JSONObject jt = null;
        if (StringUtils.isNotBlank(external_contact)) {
            jt = JSON.parseObject(external_contact);
            name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
            if (StringUtils.isBlank(name)) {
                name = "--";
            }
            friendType = jt.getInteger("type");
            avatar = jt.getString("avatar");
        }
        if (StringUtils.isNotBlank(uj_follow_user)) {
            JSONArray j = JSON.parseArray(uj_follow_user);
            String uj_userId = "";
            for (Object object : j) {
                ExternalUserPojo pojo = new ExternalUserPojo();
                String followJson = JSON.toJSONString(object);
                JSONObject follow = JSON.parseObject(followJson);
                uj_userId = follow.getString("userid");
                if (jt != null) {
                    externalUserId = jt.getString("external_userid");
                    createTime = follow.getString("createtime");
                }
                pojo.setExternalUserId(externalUserId);
                pojo.setName(name);
                pojo.setAddCreateTime(createTime);
                pojo.setWxEnterpriseId(wxEnterpriseId);
                pojo.setAvatar(avatar);
                pojo.setWxUserId(uj_userId);
                pojo.setFriendType(friendType);
                externalUserPojoList.add(pojo);
            }
        }
        return EntityUtil.changeEntityListByJSON(ExternalUserDTO.class, externalUserPojoList);
    }


}
